// A C++ implementation of the Deforable Parts-based Model (DPM) detector
// using OpenCV, and the pre-trained person model based on the INRIA set provided by
// the original author.
#ifndef _DPM_
#define _DPM_

#include <vector>
#include <iostream>
#include <fstream>
#include <string>
#include <opencv2/core/core.hpp>
//#include <opencv2/highgui/highgui.hpp>
#include <opencv2/opencv.hpp>
#include <opencv2/dpm.hpp>

using namespace cv::dpm;
using std::vector;
using std::string;
using std::cout;
using std::endl;


class DPM {

private:
    
   // Setst the minimun confidence score to accept detections. MOT2016 uses a threshold of -1. (section 3.2)
    // #define THRESHOLD -1 
    double threshold;
    cv::Ptr<DPMDetector> detector;


public:
    // Fills vec with detections from the frame at image_path 
    // dets format: [det_num][x1, y1, x2, y2, confidence_score]
    void get_detections(string& image_path, int frame, vector<vector<float>>& sort_detections, vector<vector<double>>& results);

    //DPMDetector::create(vector<string>{"/mnt/c/Users/Me/Documents/TRUE_SORT/models/inriaperson.xml"});
    DPM(double _threshhold = -1, string model = "models/inriaperson.xml");

};

#endif
