#ifndef _EVALDET_
#define _EVALDET_

// The following fuctions are used to calculate precision/recall of detection
#include <algorithm>
#include <vector>
#include <cassert>
#include <float.h> // for DBL_MAX
//#include "utils/hungarian.h"
#include "utils.hpp"
//#include "cleanData.hpp"

using std::vector;
using std::string; 

// functor used in sorting detection data by confidense score, during gt matching
struct byScore{
    byScore(size_t _in) : score_index(_in) {}

    bool operator()(VD& lhs, VD& rhs){
        return lhs[score_index] > rhs[score_index];
    }

    size_t score_index;
};

// main evaluation script
void evalDet(vector<string>& sequences, VVVD& pre_clean_dets);

// calculates overlap percent between one potential ground truth and detection match
//      ignore is a hold-over from original MOT code
double compOa(VD& gt, VD& det, bool ignore);
// matches one det to one gt. First assigns highest confidence score det
void matchDet(VVVD& gt, VVVD& det, VI& gt_match, VVD& det_match);
// calculates Precision/Recall curve with assigments from matchDet
void compPR(VI& gt, VVD& dt, VD& ref, VD& xs, VD& ys);
// port of a large MOT script that calculates many eval metrics
void clear_mod_hun(VVVD& gt, VVVD& det);


#endif
