#ifndef _KALMAN_BOX_TRACKER_
#define _KALMAN_BOX_TRACKER_

#include <opencv2/video/tracking.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <vector>
using cv::KalmanFilter;
using cv::Mat;
using std::vector;

class KalmanBoxTracker {
private:
    //private member variables
    static int count;
    int time_since_update;
    int id;
    vector<vector<float> > history;
    int hits;
    int hit_streak;
    int age;
    KalmanFilter kf;
public:
    KalmanBoxTracker(vector<float> bbox);
    void update(vector<float> bbox);
    vector<float> predict();
    vector<float> get_state();
    int get_hit_streak();
	int get_hits();
    int get_time_since_update();
    int get_id();
};


#endif
